# DLL

Infinite8 device library for use in SDKs

# I8DeviceDLL

I8DeviceDLL is a library package for a 3rd party to be able make use of Infinite8 Devices without any desctop application.
There is some classes and methodes in this dll file for users to minimize complexiti of hardware protocols.
With this pakage users can easily connect to any Infinite8 devices from many programming languege including C++, matlab and python.

## Getting Started (python)

This dll requires the following packages to work fine.

### Prerequisites

Use pip script to install `scipy` , `numpy`and `pythonnet` . These packages are used to read .dll files writen in C# and calculate some anticipated data.
```
pip install scipy
pip install numpy
pip install pythonnet
```

### import dll file

After installing the requrment packages, import ".net for python" (clr) and make a reference (copy) of the .dll file with this commands: 

```
import clr
clr.AddReference(the absolute path of i8.dll file)
# for example: clr.AddReference('C:/Users/i8-tech/Desktop/csharp_dlls/infinite8dll/I8Library1/bin/Debug/I8Library1.dll')
```
### instance from main class of i8devices
Just import `Device` class, And then you can use it by declaring an instance of `Device` class.
```
from I8Devices import Device
myAwsomeHolyShitImDyingForThisDevice = Device()

```
## How to Use

First of all, you should plug your device into your PC, and also install `ST micro COM Port Package` from `Device Manager` (it should be installed itself if your connected to internet).
After that type in the `connecting` method   

```
myAwsomeHolyShitImDyingForThisDevice.ConnectToDevice()

```

If device is successfully connected to the PC, you can Use the following methods and properties to retrieve Device information or send a command to it:

```
# Info
    myDevice.name

# get data
   myDevice.StartDataAcquisition()
   myDevice.get_data()
   myDevice.StoptDataAcquisition()


```

## Built With
* [C# dll .net] (https://docs.microsoft.com/en-us/dotnet/api/system.io.ports.serialport.pinchanged?view=netframework-4.8)
* [numpy](https://pypi.org/project/numpy/) - Used to calculate some shit
* [scipy](https://pypi.org/project/scipy/) - Used to calculate some real shit

## Contributing

When contributing to this repository, please first discuss the change you wish to make via issue, email, or any other method with the owners of this repository before making a change.

Please note we have a code of conduct, please follow it in all your interactions with the project.

### Pull Request Process

1. Ensure any install or build dependencies are removed before the end of the layer when doing a 
   build.
2. Update the README.md with details of changes to the interface, this includes new environment 
   variables, exposed ports, useful file locations and container parameters.
3. Increase the version numbers in any examples files and the README.md to the new version that this
   Pull Request would represent. The versioning scheme we use is [SemVer](http://semver.org/).
4. You may merge the Pull Request in once you have the sign-off of two other developers, or if you 
   do not have permission to do that, you may request the second reviewer to merge it for you.

## Versioning

We use [SemVer](http://semver.org/) for versioning. The current released version is 0.2.5.

## Authors

* **Varnos** - *Initial work* - [Varnos](http://51.75.64.148/reza)

## License

This project is licensed under the I8 Co. License - see the [Infinite8 website](https://infinite8.tech) website for details. (you wish there will be some information but I gotta tell you there is not )